#include <bits/stdc++.h>

using namespace std;

int gcd(int a,int b){
    if(b==0){
        return a;
    }
    return gcd(b,a%b);
}

int main(){
    ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);
    int t;
    cin>>t;
    for(int i=0;i<t;i++){
        long long n,m,a;
        cin>>n>>m;
        vector<long long> v;
        for(int j=0;j<n;j++){
            cin>>a;
            v.push_back(a);
        }
        sort(v.begin(),v.end());
        long long maxdif=v[1]-v[0];
        for(int j=2;j<n;j++){
            maxdif=gcd(maxdif,v[j]-v[j-1]);
        }
        bool found=false;
        for(int j=0;j<m;j++){
            cin>>a;
            if((a-v[0])%maxdif==0){
                found=true;
            }
        }
        if(found){
            cout<<0<<endl;
        }
        else{
            cout<<1<<endl;
        }
    }
    return 0;
}